package cn.iocoder.yudao.module.pms.service.inspect;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.pms.controller.admin.inspect.order.vo.IotInspectOrderPageReqVO;
import cn.iocoder.yudao.module.pms.controller.admin.inspect.order.vo.IotInspectOrderSaveReqVO;
import cn.iocoder.yudao.module.pms.dal.dataobject.inspect.IotInspectOrderDO;
import cn.iocoder.yudao.module.pms.dal.dataobject.inspect.IotInspectPlanDO;

import javax.validation.Valid;
import java.util.List;
import java.util.Map;

/**
 * 巡检工单 Service 接口
 *
 * @author 芋道源码
 */
public interface IotInspectOrderService {
    void writeInspectOrderDetail(Map<String, String> requestMaps, Long orderId);
    /**
     * 创建巡检工单
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createIotInspectOrder(@Valid IotInspectOrderSaveReqVO createReqVO);

    /**
     * 更新巡检工单
     *
     * @param updateReqVO 更新信息
     */
    void updateIotInspectOrder(@Valid IotInspectOrderSaveReqVO updateReqVO);

    /**
     * 删除巡检工单
     *
     * @param id 编号
     */
    void deleteIotInspectOrder(Long id);

    /**
     * 获得巡检工单
     *
     * @param id 编号
     * @return 巡检工单
     */
    IotInspectOrderDO getIotInspectOrder(Long id);

    /**
     * 获得巡检工单分页
     *
     * @param pageReqVO 分页查询
     * @return 巡检工单分页
     */
    PageResult<IotInspectOrderDO> getIotInspectOrderPage(IotInspectOrderPageReqVO pageReqVO);
    PageResult<IotInspectOrderDO> getIotInspectOrderPageApp(IotInspectOrderPageReqVO pageReqVO);

    /**
     * 调拨后同步 维修 保养 巡检 工单历史数据
     * @param deviceIds 设备id集合
     * @param deptId 调拨后的部门id
     */
    void syncWordOrderData(List<Long> deviceIds, Long deptId);
    void createPlan(IotInspectPlanDO planDO);
}
